using FishFactoryContracts.BindingModels;
using FishFactoryContracts.BusinessLogicsContracts;
using FishFactoryContracts.SearchModels;
using FishFactoryContracts.ViewModels;
using Microsoft.AspNetCore.Mvc;

namespace FishFactoryRestApi.Controllers
{
    [Route("api/[controller]/[action]")]
    [ApiController]
    public class MainController : Controller
    {
        private readonly ILogger _logger;

        private readonly IOrderLogic _order;

        private readonly ICannedLogic _Canned;

        public MainController(ILogger<MainController> logger, IOrderLogic order, ICannedLogic Canned)
        {
            _logger = logger;
            _order = order;
            _Canned = Canned;
        }

        [HttpGet]
        public List<CannedViewModel>? GetListCanned()
        {
            try
            {
                return _Canned.ReadList(null);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, "Ошибка получения списка консерв");
                throw;
            }
        }

        [HttpGet]
        public CannedViewModel? GetCanned(int CannedId)
        {
            try
            {
                return _Canned.ReadElement(new CannedSearchModel { Id = CannedId });
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, "Ошибка получения консервы по id={Id}", CannedId);
                throw;
            }
        }

        [HttpGet]
        public List<OrderViewModel>? GetOrders(int clientId)
        {
            try
            {
                return _order.ReadList(new OrderSearchModel { ClientId = clientId });
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, "Ошибка получения списка заказов клиента id={Id}", clientId);
                throw;
            }
        }

        [HttpPost]
        public void CreateOrder(OrderBindingModel model)
        {
            try
            {
                _order.CreateOrder(model);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, "Ошибка создания заказа");
                throw;
            }
        }
    }
}